/* Plug.c generated by valac 0.56.17, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * Copyright 2014-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include "datetime.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <adwaita.h>
#include <granite-7.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DATE_TIME_PLUG_0_PROPERTY,
	DATE_TIME_PLUG_NUM_PROPERTIES
};
static GParamSpec* date_time_plug_properties[DATE_TIME_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DateTimePlugSearchData DateTimePlugSearchData;

struct _DateTimePlugPrivate {
	GtkBox* box;
};

struct _DateTimePlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DateTimePlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
};

static gint DateTimePlug_private_offset;
static gpointer date_time_plug_parent_class = NULL;

static GtkWidget* date_time_plug_real_get_widget (SwitchboardPlug* base);
static void date_time_plug_real_shown (SwitchboardPlug* base);
static void date_time_plug_real_hidden (SwitchboardPlug* base);
static void date_time_plug_real_search_callback (SwitchboardPlug* base,
                                          const gchar* location);
static void date_time_plug_real_search_data_free (gpointer _data);
static void date_time_plug_real_search (SwitchboardPlug* base,
                                 const gchar* search,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static gboolean date_time_plug_real_search_co (DateTimePlugSearchData* _data_);
static void date_time_plug_finalize (GObject * obj);
static GType date_time_plug_get_type_once (void);

static inline gpointer
date_time_plug_get_instance_private (DateTimePlug* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimePlug_private_offset);
}

DateTimePlug*
date_time_plug_construct (GType object_type)
{
	DateTimePlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 24 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 25 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 27 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 27 "../src/Plug.vala"
	settings = _tmp0_;
#line 28 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "time", NULL);
#line 29 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "date", NULL);
#line 30 "../src/Plug.vala"
	self = (DateTimePlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_SYSTEM, "code-name", "io.elementary.settings.datetime", "display-name", _ ("Date & Time"), "description", _ ("Configure date, time, and select time zone"), "icon", "preferences-system-time", "supported-settings", settings, NULL);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 23 "../src/Plug.vala"
	return self;
#line 137 "Plug.c"
}

DateTimePlug*
date_time_plug_new (void)
{
#line 23 "../src/Plug.vala"
	return date_time_plug_construct (DATE_TIME_TYPE_PLUG);
#line 145 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 153 "Plug.c"
}

static GtkWidget*
date_time_plug_real_get_widget (SwitchboardPlug* base)
{
	DateTimePlug * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp9_;
	GtkWidget* _tmp10_;
	GtkWidget* result;
#line 38 "../src/Plug.vala"
	self = (DateTimePlug*) base;
#line 39 "../src/Plug.vala"
	_tmp0_ = self->priv->box;
#line 39 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 170 "Plug.c"
		AdwHeaderBar* headerbar = NULL;
		AdwHeaderBar* _tmp1_ = NULL;
		AdwHeaderBar* _tmp2_;
		DateTimeMainView* main_view = NULL;
		DateTimeMainView* _tmp3_ = NULL;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		AdwHeaderBar* _tmp6_;
		GtkBox* _tmp7_;
		DateTimeMainView* _tmp8_;
#line 40 "../src/Plug.vala"
		_tmp1_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 40 "../src/Plug.vala"
		adw_header_bar_set_show_title (_tmp1_, FALSE);
#line 40 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 40 "../src/Plug.vala"
		headerbar = _tmp1_;
#line 43 "../src/Plug.vala"
		_tmp2_ = headerbar;
#line 43 "../src/Plug.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp2_, GRANITE_STYLE_CLASS_FLAT);
#line 45 "../src/Plug.vala"
		_tmp3_ = date_time_main_view_new ();
#line 45 "../src/Plug.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
#line 45 "../src/Plug.vala"
		g_object_ref_sink (_tmp3_);
#line 45 "../src/Plug.vala"
		main_view = _tmp3_;
#line 49 "../src/Plug.vala"
		_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 49 "../src/Plug.vala"
		g_object_ref_sink (_tmp4_);
#line 49 "../src/Plug.vala"
		_g_object_unref0 (self->priv->box);
#line 49 "../src/Plug.vala"
		self->priv->box = _tmp4_;
#line 50 "../src/Plug.vala"
		_tmp5_ = self->priv->box;
#line 50 "../src/Plug.vala"
		_tmp6_ = headerbar;
#line 50 "../src/Plug.vala"
		gtk_box_append (_tmp5_, (GtkWidget*) _tmp6_);
#line 51 "../src/Plug.vala"
		_tmp7_ = self->priv->box;
#line 51 "../src/Plug.vala"
		_tmp8_ = main_view;
#line 51 "../src/Plug.vala"
		gtk_box_append (_tmp7_, (GtkWidget*) _tmp8_);
#line 39 "../src/Plug.vala"
		_g_object_unref0 (main_view);
#line 39 "../src/Plug.vala"
		_g_object_unref0 (headerbar);
#line 225 "Plug.c"
	}
#line 54 "../src/Plug.vala"
	_tmp9_ = self->priv->box;
#line 54 "../src/Plug.vala"
	_tmp10_ = _g_object_ref0 ((GtkWidget*) _tmp9_);
#line 54 "../src/Plug.vala"
	result = _tmp10_;
#line 54 "../src/Plug.vala"
	return result;
#line 235 "Plug.c"
}

static void
date_time_plug_real_shown (SwitchboardPlug* base)
{
	DateTimePlug * self;
#line 57 "../src/Plug.vala"
	self = (DateTimePlug*) base;
#line 244 "Plug.c"
}

static void
date_time_plug_real_hidden (SwitchboardPlug* base)
{
	DateTimePlug * self;
#line 60 "../src/Plug.vala"
	self = (DateTimePlug*) base;
#line 253 "Plug.c"
}

static void
date_time_plug_real_search_callback (SwitchboardPlug* base,
                                     const gchar* location)
{
	DateTimePlug * self;
#line 63 "../src/Plug.vala"
	self = (DateTimePlug*) base;
#line 63 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 265 "Plug.c"
}

static void
date_time_plug_real_search_data_free (gpointer _data)
{
	DateTimePlugSearchData* _data_;
	_data_ = _data;
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Plug.vala"
	g_slice_free (DateTimePlugSearchData, _data_);
#line 281 "Plug.c"
}

static void
date_time_plug_real_search (SwitchboardPlug* base,
                            const gchar* search,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	DateTimePlug * self;
	DateTimePlugSearchData* _data_;
	DateTimePlug* _tmp0_;
	gchar* _tmp1_;
#line 20 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 20 "../src/Plug.vala"
	self = (DateTimePlug*) base;
#line 20 "../src/Plug.vala"
	_data_ = g_slice_new0 (DateTimePlugSearchData);
#line 20 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, date_time_plug_real_search_data_free);
#line 20 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 20 "../src/Plug.vala"
	date_time_plug_real_search_co (_data_);
#line 316 "Plug.c"
}

static GeeTreeMap*
date_time_plug_search_finish (SwitchboardPlug* base,
                              GAsyncResult* _res_)
{
	GeeTreeMap* result;
	DateTimePlugSearchData* _data_;
#line 20 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 20 "../src/Plug.vala"
	result = _data_->result;
#line 20 "../src/Plug.vala"
	_data_->result = NULL;
#line 20 "../src/Plug.vala"
	return result;
#line 333 "Plug.c"
}

static gboolean
date_time_plug_real_search_co (DateTimePlugSearchData* _data_)
{
#line 67 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 67 "../src/Plug.vala"
		case 0:
#line 343 "Plug.c"
		goto _state_0;
		default:
#line 67 "../src/Plug.vala"
		g_assert_not_reached ();
#line 348 "Plug.c"
	}
	_state_0:
#line 68 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 68 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 68 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 68 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 69 "../src/Plug.vala"
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 69 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 69 "../src/Plug.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Time Format"));
#line 69 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 69 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, "");
#line 69 "../src/Plug.vala"
	_g_free0 (_data_->_tmp6_);
#line 70 "../src/Plug.vala"
	_data_->_tmp7_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 70 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 70 "../src/Plug.vala"
	_data_->_tmp9_ = g_strdup_printf ("%s → %s", _data_->_tmp8_, _ ("Time Zone"));
#line 70 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 70 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp10_, "");
#line 70 "../src/Plug.vala"
	_g_free0 (_data_->_tmp10_);
#line 71 "../src/Plug.vala"
	_data_->_tmp11_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 71 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 71 "../src/Plug.vala"
	_data_->_tmp13_ = g_strdup_printf ("%s → %s", _data_->_tmp12_, _ ("Network Time"));
#line 71 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 71 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp14_, "");
#line 71 "../src/Plug.vala"
	_g_free0 (_data_->_tmp14_);
#line 72 "../src/Plug.vala"
	_data_->_tmp15_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 72 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 72 "../src/Plug.vala"
	_data_->_tmp17_ = g_strdup_printf ("%s → %s", _data_->_tmp16_, _ ("Show Week Numbers"));
#line 72 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 72 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp18_, "");
#line 72 "../src/Plug.vala"
	_g_free0 (_data_->_tmp18_);
#line 73 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 73 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 73 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 73 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 73 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 417 "Plug.c"
		}
	}
#line 73 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 73 "../src/Plug.vala"
	return FALSE;
#line 424 "Plug.c"
}

static void
date_time_plug_class_init (DateTimePlugClass * klass,
                           gpointer klass_data)
{
#line 20 "../src/Plug.vala"
	date_time_plug_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &DateTimePlug_private_offset);
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) date_time_plug_real_get_widget;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) date_time_plug_real_shown;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) date_time_plug_real_hidden;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) date_time_plug_real_search_callback;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) date_time_plug_real_search;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) date_time_plug_search_finish;
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = date_time_plug_finalize;
#line 449 "Plug.c"
}

static void
date_time_plug_instance_init (DateTimePlug * self,
                              gpointer klass)
{
#line 20 "../src/Plug.vala"
	self->priv = date_time_plug_get_instance_private (self);
#line 458 "Plug.c"
}

static void
date_time_plug_finalize (GObject * obj)
{
	DateTimePlug * self;
#line 20 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_PLUG, DateTimePlug);
#line 21 "../src/Plug.vala"
	_g_object_unref0 (self->priv->box);
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (date_time_plug_parent_class)->finalize (obj);
#line 471 "Plug.c"
}

static GType
date_time_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimePlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimePlug), 0, (GInstanceInitFunc) date_time_plug_instance_init, NULL };
	GType date_time_plug_type_id;
	date_time_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "DateTimePlug", &g_define_type_info, 0);
	DateTimePlug_private_offset = g_type_add_instance_private (date_time_plug_type_id, sizeof (DateTimePlugPrivate));
	return date_time_plug_type_id;
}

GType
date_time_plug_get_type (void)
{
	static volatile gsize date_time_plug_type_id__once = 0;
	if (g_once_init_enter (&date_time_plug_type_id__once)) {
		GType date_time_plug_type_id;
		date_time_plug_type_id = date_time_plug_get_type_once ();
		g_once_init_leave (&date_time_plug_type_id__once, date_time_plug_type_id);
	}
	return date_time_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	DateTimePlug* plug = NULL;
	DateTimePlug* _tmp0_;
	SwitchboardPlug* result;
#line 77 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 78 "../src/Plug.vala"
	g_debug ("Plug.vala:78: Activating Date & Time plug");
#line 79 "../src/Plug.vala"
	_tmp0_ = date_time_plug_new ();
#line 79 "../src/Plug.vala"
	plug = _tmp0_;
#line 80 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 80 "../src/Plug.vala"
	return result;
#line 514 "Plug.c"
}

